package gag.xtp;

import java.awt.*;
import java.awt.image.ImageProducer;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ImageCanvas extends Canvas {
  protected Dimension     size;
  protected ImageProducer imageProducer = null;
  protected Image         image = null;

  public ImageCanvas( int width, int height) {
    size = new Dimension( width, height);
    clearImageProducer();
  }

  public Dimension preferredSize() { return size; }
  public ImageProducer getImageProducer  ()  { return imageProducer; }
  public void          setImageProducer  ( ImageProducer imageProducer) {
    this.imageProducer = imageProducer;
    image = this.createImage( imageProducer);
  }
  public void          clearImageProducer()  { 
    imageProducer = null;
    image         = null;
  }

  public void paint( Graphics g) {
    if (image != null)
      g.drawImage( image, 0, 0, this);
    else
      System.err.println("No IMAGE!");
  }
}
