package gag.xtp;

import  java.awt.image.ImageProducer;
import  rsf.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class RsfImageProducer {
  float xScale, yScale;
  Rsf2   myrsf;
  int   n0, n1;
  float lo, hi;
  ImageProducer imageProducer = null;

  public RsfImageProducer(Rsf  myrsf, int height, int width,
			  float clipLo, float clipHi) {
    new RsfImageProducer((Rsf2) myrsf, height, width, clipLo, clipHi); 
  }

  public RsfImageProducer(Rsf2  myrsf, int height, int width,
			  float clipLo, float clipHi) {
    n0 = ((RsfSpace) myrsf.getSpace()).getNSamples(0);
    n1 = ((RsfSpace) myrsf.getSpace()).getNSamples(1);
    xScale = width  / (float) n0;
    yScale = height / (float) n1;
    lo = clipLo;
    hi = clipHi;
    this.myrsf = myrsf;
  }

  public ImageProducer getImageProducer() {
    if (imageProducer == null)
      makeImageProducer();
    return imageProducer;
  }

  void makeImageProducer() {
    byte[] bytes  = new Taplot(lo, hi).toBytes( myrsf.d );
    RasterScale scaler = new RasterScale(xScale, yScale, n0);
    byte[] pixmap = scaler.scaleRaster(bytes);
    imageProducer = new RasterImage(scaler.scaleX(n0),
				    scaler.scaleY(n1)).makeImage(pixmap);
  }

}

