package gag.xtpF;

import java.io.File;
import java.io.IOException;
import java.io.FilenameFilter;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class Executor {
  static final String make = "/usr/local/bin/gmake ";

  public int clean() {
    Shell.outputExec(make + "clean", System.out);
    return 0;
    //    Old version using Java instead of Make
    //    --------------------------------------
    //    System.out.println("clean (partly implemented)");
    //    rm(new SuffixFilter("~"));
    //    rm(new SuffixFilter(".class"));
    //    return 0;
  }    
  public int build() {
    Shell.outputExec(make + "build", System.out);
    return 0;
  }    
  public int burn() {
    Shell.outputExec(make + "burn", System.out);
    return 0;
  }    
  public int view() {
    Shell.outputExec(make + "view", System.out);
    return 0;
  }    

  // remove all files which are accepted by filter from
  // the current directory (As specified by user.dir).
  void rm(FilenameFilter filter) {
    File cd = new File(System.getProperty("user.dir"));
    String[] files = cd.list();
    for (int i = 0; i < files.length; i++)
      if (filter.accept(cd,files[i]))
	new File(files[i]).delete();
  }
}

class SuffixFilter implements FilenameFilter {
  public SuffixFilter(String suffix) { this.suffix = suffix; }
  public boolean accept(File dir, String name) {
    return name.endsWith(suffix);
  }

  String suffix;
}
