package gag.xtpF;

import java.awt.Image;
import java.awt.image.MemoryImageSource;
import java.awt.image.ImageProducer;
import java.awt.image.IndexColorModel;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
final public class RasterImage {
  int width;
  int height;

  static IndexColorModel gray256;

  static {
    byte[] grays = new byte[256];
    for (int i = 0; i < 256; i++ )
      grays[i] = (byte) i;
    gray256 = new IndexColorModel( 8, 256, grays, grays, grays);
  }

  public RasterImage( int width, int height) {
    this.width  = width;
    this.height = height;
  }

  public ImageProducer makeImage( byte[] bytes) {
    if (bytes.length != width*height) {
      System.err.println( "Error in RasterImage.makeImage() : " +
			  "(size of bytes[]) != (width*height).");
    }
    return new MemoryImageSource( width, height, gray256, bytes, 0, width);
  }
}
