package gag.xtpF;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
final public class RasterScale {
  float xScale, yScale;
  int   oldW, oldH;

  public RasterScale( float scale, int width) { this( scale, scale, width); }

  public RasterScale( float xScale, float yScale, int width) {
    this.xScale = xScale;
    this.yScale = yScale;
    this.oldW   = width;
  }

  public int scaleX(int n) { return (int) ( n * xScale); }
  public int scaleY(int n) { return (int) ( n * yScale); }

  public byte[] scaleRaster(byte[] data) {
    oldH =  data.length / oldW;
    //    byte[] tdata = transpose(data);
    byte[] tdata = data;
    int newW = scaleX(oldW);
    int newH = scaleY(oldH);
    byte[] scaledData = new byte[newW * newH];
    int i = 0;
    for (int y = 0; y < newH; y++)
      for (int x = 0; x < newW; x++, i++)
	scaledData[i] = tdata[unscaledIndex(x, y)];
    return scaledData;
  }    

  byte[] transpose(byte[] bytes) {
    byte[] newBytes = new byte[bytes.length];

    System.out.println(oldW + " " + oldH);
    int ind1 = 0;
    for   (int y = 0; y < oldH; y++)
      for (int x = 0; x < oldW; x++, ind1++)
	newBytes[y + x*oldH] = bytes[ind1];
    return newBytes;
  }

  // given a scaled coordinate, find the index into the non-scaled array
  int unscaledIndex( int x, int y) {
    return (oldW * ((int) ( y / yScale))) + ((int) (x / xScale));
  }
}
