package  gag.xtpF;

import  java.awt.image.ImageProducer;
import   rsfF.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class RsfImageProducer {
  float xScale, yScale;
  Rsf   rsf;
  int n0, n1;
  ImageProducer imageProducer = null;
  float lo, hi;

  public RsfImageProducer( Rsf rsf, int height, int width,
			   float clipLo, float clipHi) {
    n0 = ((RsfSpace) rsf.getSpace()).getNSamples(0);
    n1 = ((RsfSpace) rsf.getSpace()).getNSamples(1);
    xScale = width  / (float) n0;
    yScale = height / (float) n1;
    lo = clipLo;
    hi = clipHi;
    this.rsf = rsf;
  }

  public ImageProducer getImageProducer() {
    if ( imageProducer == null)
      makeImageProducer();
    return imageProducer;
  }

  void makeImageProducer() {
    byte[] bytes  = new Taplot( lo, hi).toBytes( rsf.getData());
    RasterScale scaler = new RasterScale( xScale, yScale, n0);
    byte[] pixmap = scaler.scaleRaster( bytes);
    imageProducer = new RasterImage( scaler.scaleX( n0),
				     scaler.scaleY( n1)).makeImage( pixmap);
  }

}
